(function ($global) { "use strict";
var $estr = function() { return js_Boot.__string_rec(this,''); },$hxEnums = $hxEnums || {},$_;
function $extend(from, fields) {
	var proto = Object.create(from);
	for (var name in fields) proto[name] = fields[name];
	if( fields.toString !== Object.prototype.toString ) proto.toString = fields.toString;
	return proto;
}
var EReg = function(r,opt) {
	this.r = new RegExp(r,opt.split("u").join(""));
};
EReg.__name__ = "EReg";
EReg.prototype = {
	match: function(s) {
		if(this.r.global) {
			this.r.lastIndex = 0;
		}
		this.r.m = this.r.exec(s);
		this.r.s = s;
		return this.r.m != null;
	}
	,__class__: EReg
};
var HxOverrides = function() { };
HxOverrides.__name__ = "HxOverrides";
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) {
		return undefined;
	}
	return x;
};
HxOverrides.substr = function(s,pos,len) {
	if(len == null) {
		len = s.length;
	} else if(len < 0) {
		if(pos == 0) {
			len = s.length + len;
		} else {
			return "";
		}
	}
	return s.substr(pos,len);
};
HxOverrides.remove = function(a,obj) {
	var i = a.indexOf(obj);
	if(i == -1) {
		return false;
	}
	a.splice(i,1);
	return true;
};
HxOverrides.now = function() {
	return Date.now();
};
var Lambda = function() { };
Lambda.__name__ = "Lambda";
Lambda.exists = function(it,f) {
	var x = $getIterator(it);
	while(x.hasNext()) {
		var x1 = x.next();
		if(f(x1)) {
			return true;
		}
	}
	return false;
};
var Main = function() { };
Main.__name__ = "Main";
Main.main = function() {
	var dock = new MyDocker();
};
Math.__name__ = "Math";
var host_Docker = function() {
};
host_Docker.__name__ = "host.Docker";
host_Docker.prototype = {
	__class__: host_Docker
};
var hxasync_Asyncable = function() { };
hxasync_Asyncable.__name__ = "hxasync.Asyncable";
hxasync_Asyncable.__isInterface__ = true;
var MyDocker = function() {
	host_Docker.call(this);
	host_App.init(this);
	var h = Defs_ui_tags.h;
	var mode_h = h;
	var mode_keys = Object.keys(h);
	var mode_length = mode_keys.length;
	var mode_current = 0;
	while(mode_current < mode_length) {
		var mode = mode_keys[mode_current++];
		console.log("src/MyDocker.hx:32:",mode);
		console.log("src/MyDocker.hx:33:",Defs_defaults.h[mode].length);
		console.log("src/MyDocker.hx:34:",Defs_ui_tags.h[mode].length);
	}
};
MyDocker.__name__ = "MyDocker";
MyDocker.__interfaces__ = [hxasync_Asyncable];
MyDocker.checkReady = async function(mode) {
	var state = await host_App.getDocumentState();
	if(state.selection == null) {
		var selection = { x : 0, y : 0, width : 512, height : 512};
		state.selection = selection;
		await host_App.setDocumentState(state);
		host_UI.toast("NOT READY: no selection existed - defaulted to 512x512");
		return false;
	} else if(state.selection.width % 64 != 0 || state.selection.height % 64 != 0) {
		host_UI.toast("NOT READY: resized selection to multiples of 64");
		state.selection.width = 64 * (1 + (state.selection.width / 64 | 0));
		state.selection.height = 64 * (1 + (state.selection.height / 64 | 0));
		await host_App.setDocumentState(state);
		return false;
	}
	if(mode == "inpaint") {
		var mask = host_Image.layerByName("!sdmask");
		if(mask == null) {
			host_UI.toast("mask needed - created visible layer called !sdmask");
			await host_Image.createLayer("!sdmask","paintlayer");
			await host_Image.special_fillBk_screen(state.selection);
			return false;
		}
	}
	return true;
};
MyDocker.__super__ = host_Docker;
MyDocker.prototype = $extend(host_Docker.prototype,{
	generate2: async function(mode,form) {
		var ready = await MyDocker.checkReady(mode);
		if(ready) {
			if(mode == "inpaint") {
				host_UI.is_inpainting = 1;
			} else {
				host_UI.is_inpainting = 0;
			}
			host_UI.toast("READY - Generating " + mode);
			var apidata = [];
			var _g = 0;
			var _g1 = form.length;
			while(_g < _g1) {
				var i = _g++;
				if(form[i]["getter"] != null) {
					var p = await form[i]["getter"]();
					apidata.push(p);
				} else {
					console.log("src/MyDocker.hx:60:","no getter - defaulting");
					console.log("src/MyDocker.hx:62:",form[i]);
					try {
						var props = form[i]["props"];
						apidata.push(props["value"]);
					} catch( _g2 ) {
						var e = haxe_Exception.caught(_g2);
						console.log("src/MyDocker.hx:66:",e);
					}
				}
			}
			console.log("src/MyDocker.hx:71:",apidata);
			Utils.request(mode,apidata);
		}
	}
	,generate: async function(mode) {
		var ready = await MyDocker.checkReady(mode);
		if(ready) {
			host_UI.toast("READY - Generating " + mode);
			var apidata = [];
			var _g = 0;
			var _g1 = Defs_defaults.h[mode].length;
			while(_g < _g1) {
				var i = _g++;
				if(Defs_ui_tags.h[mode][i] != null) {
					console.log("src/MyDocker.hx:92:",Defs_ui_tags.h[mode][i]);
					var p = await host_UI.gatherParameter(Defs_ui_tags.h[mode][i]);
					console.log("src/MyDocker.hx:94:",p);
					apidata.push(p);
				} else {
					apidata.push(Defs_defaults.h[mode][i]);
				}
			}
			Utils.request(mode,apidata);
		}
	}
	,__class__: MyDocker
});
var Reflect = function() { };
Reflect.__name__ = "Reflect";
Reflect.getProperty = function(o,field) {
	var tmp;
	if(o == null) {
		return null;
	} else {
		var tmp1;
		if(o.__properties__) {
			tmp = o.__properties__["get_" + field];
			tmp1 = tmp;
		} else {
			tmp1 = false;
		}
		if(tmp1) {
			return o[tmp]();
		} else {
			return o[field];
		}
	}
};
Reflect.fields = function(o) {
	var a = [];
	if(o != null) {
		var hasOwnProperty = Object.prototype.hasOwnProperty;
		for( var f in o ) {
		if(f != "__id__" && f != "hx__closures__" && hasOwnProperty.call(o,f)) {
			a.push(f);
		}
		}
	}
	return a;
};
Reflect.isFunction = function(f) {
	if(typeof(f) == "function") {
		return !(f.__name__ || f.__ename__);
	} else {
		return false;
	}
};
Reflect.compareMethods = function(f1,f2) {
	if(f1 == f2) {
		return true;
	}
	if(!Reflect.isFunction(f1) || !Reflect.isFunction(f2)) {
		return false;
	}
	if(f1.scope == f2.scope && f1.method == f2.method) {
		return f1.method != null;
	} else {
		return false;
	}
};
var Std = function() { };
Std.__name__ = "Std";
Std.string = function(s) {
	return js_Boot.__string_rec(s,"");
};
Std.parseInt = function(x) {
	if(x != null) {
		var _g = 0;
		var _g1 = x.length;
		while(_g < _g1) {
			var i = _g++;
			var c = x.charCodeAt(i);
			if(c <= 8 || c >= 14 && c != 32 && c != 45) {
				var nc = x.charCodeAt(i + 1);
				var v = parseInt(x,nc == 120 || nc == 88 ? 16 : 10);
				if(isNaN(v)) {
					return null;
				} else {
					return v;
				}
			}
		}
	}
	return null;
};
var ValueType = $hxEnums["ValueType"] = { __ename__:true,__constructs__:null
	,TNull: {_hx_name:"TNull",_hx_index:0,__enum__:"ValueType",toString:$estr}
	,TInt: {_hx_name:"TInt",_hx_index:1,__enum__:"ValueType",toString:$estr}
	,TFloat: {_hx_name:"TFloat",_hx_index:2,__enum__:"ValueType",toString:$estr}
	,TBool: {_hx_name:"TBool",_hx_index:3,__enum__:"ValueType",toString:$estr}
	,TObject: {_hx_name:"TObject",_hx_index:4,__enum__:"ValueType",toString:$estr}
	,TFunction: {_hx_name:"TFunction",_hx_index:5,__enum__:"ValueType",toString:$estr}
	,TClass: ($_=function(c) { return {_hx_index:6,c:c,__enum__:"ValueType",toString:$estr}; },$_._hx_name="TClass",$_.__params__ = ["c"],$_)
	,TEnum: ($_=function(e) { return {_hx_index:7,e:e,__enum__:"ValueType",toString:$estr}; },$_._hx_name="TEnum",$_.__params__ = ["e"],$_)
	,TUnknown: {_hx_name:"TUnknown",_hx_index:8,__enum__:"ValueType",toString:$estr}
};
ValueType.__constructs__ = [ValueType.TNull,ValueType.TInt,ValueType.TFloat,ValueType.TBool,ValueType.TObject,ValueType.TFunction,ValueType.TClass,ValueType.TEnum,ValueType.TUnknown];
var Type = function() { };
Type.__name__ = "Type";
Type.createInstance = function(cl,args) {
	var ctor = Function.prototype.bind.apply(cl,[null].concat(args));
	return new (ctor);
};
Type.typeof = function(v) {
	switch(typeof(v)) {
	case "boolean":
		return ValueType.TBool;
	case "function":
		if(v.__name__ || v.__ename__) {
			return ValueType.TObject;
		}
		return ValueType.TFunction;
	case "number":
		if(Math.ceil(v) == v % 2147483648.0) {
			return ValueType.TInt;
		}
		return ValueType.TFloat;
	case "object":
		if(v == null) {
			return ValueType.TNull;
		}
		var e = v.__enum__;
		if(e != null) {
			return ValueType.TEnum($hxEnums[e]);
		}
		var c = js_Boot.getClass(v);
		if(c != null) {
			return ValueType.TClass(c);
		}
		return ValueType.TObject;
	case "string":
		return ValueType.TClass(String);
	case "undefined":
		return ValueType.TNull;
	default:
		return ValueType.TUnknown;
	}
};
var Utils = function() { };
Utils.__name__ = "Utils";
Utils.__interfaces__ = [hxasync_Asyncable];
Utils.request = function(mode,in_data) {
	var fn_i = null;
	if(mode == "txt2img") {
		fn_i = host_UI.txt2img_generate_fn_index;
	} else {
		fn_i = host_UI.img2img_generate_fn_index;
	}
	var data_formatted = JSON.stringify({ fn_index : fn_i, data : in_data, session_hash : null});
	console.log("src/Utils.hx:49:",data_formatted);
	var req = new haxe_http_HttpJs("http://localhost.tech:7860/api/predict");
	req.addHeader("Content-Type","application/json");
	req.addHeader("Content-Length",in_data.length == null ? "null" : "" + in_data.length);
	req.setPostData(data_formatted);
	req.onData = function(data_out) {
		Utils.receive(data_out);
	};
	req.onStatus = function(status) {
		console.log("src/Utils.hx:63:",status);
	};
	req.request(true);
};
Utils.receive = async function(data) {
	console.log("src/Utils.hx:88:","we get signal");
	var obj = JSON.parse(data);
	console.log("src/Utils.hx:90:",obj);
	var prefix = "data:image/png;base64,";
	var string_array = obj.data[0];
	var response_dict = JSON.parse(obj.data[1]);
	var _g = 0;
	var _g1 = string_array.length;
	while(_g < _g1) {
		var i = _g++;
		var finfo = string_array[i];
		var name = Utils.packInfo(response_dict);
		var bytes = await Utils.fetch_remote_png(finfo["name"]);
		await host_Image.layerFromPng(bytes,name);
		var _g2 = response_dict;
		_g2["seed"] = _g2["seed"] + 1;
		var _g3 = response_dict;
		_g3["subseed"] = _g3["subseed"] + 1;
	}
	host_UI.toast("OK - Generation finished for " + string_array.length + " image(s)!");
};
Utils.fetch_remote_png = function(fname) {
	var data = null;
	var url = "http://localhost.tech:7860/file=" + fname;
	var promise = new Promise(function(resolve,reject) {
		var req = new haxe_http_HttpJs(url);
		req.onBytes = function(response) {
			data = response.b.bufferValue;
			resolve(data);
		};
		req.request(false);
	});
	return promise;
};
Utils.packInfo = function(info) {
	var info_stripped = { };
	var _g = 0;
	var _g1 = Reflect.fields(info);
	while(_g < _g1.length) {
		var key = _g1[_g];
		++_g;
		if(host_UIDefs_widgetinfo.h[key] != null && info[key] != null) {
			info_stripped[key] = info[key];
		}
	}
	console.log("src/Utils.hx:160:",info_stripped);
	Utils.params_for_layer.push(info_stripped);
	return "!i=" + (Utils.params_for_layer.length - 1);
};
Utils.unpackInfo = function(layer) {
	if(layer.name.indexOf("!i=") != -1) {
		var id = layer.name.split("!i=")[1];
		return Utils.params_for_layer[Std.parseInt(id)];
	} else {
		return null;
	}
};
Utils.fetchAndInsert = function(layer,components) {
	var params = Utils.unpackInfo(layer);
	var props = null;
	var _g = 0;
	while(_g < components.length) {
		var comp = components[_g];
		++_g;
		props = comp["props"];
		if(params[props["param_name"]] != null) {
			comp["setter"](params[props["param_name"]]);
		}
	}
};
Utils.cleanTags = function(tags) {
	var _g = 0;
	while(_g < tags.length) {
		var component = tags[_g];
		++_g;
		Utils.cleanComponent(component);
	}
};
Utils.cleanComponent = function(component) {
	var props = component["props"];
	if(props["label"] != null) {
		props["param_name"] = props["label"].toLowerCase().replace(" ","_").replace(" ","_").replace(" ","_").replace(" ","_").replace(".","").replace("\n","_");
	} else {
		props["param_name"] = Std.string(component["id"]);
	}
	if(Object.prototype.hasOwnProperty.call(host_UIDefs_parameterNames.h,props["param_name"])) {
		console.log("src/Utils.hx:223:",props["param_name"]);
		props["param_name"] = host_UIDefs_parameterNames.h[props["param_name"]];
	}
};
Utils.fastdecode64 = function(data) {
	var bytes = haxe_crypto_Base64.decode(data).b.bufferValue;
	return bytes;
};
Utils.fastencode64 = function(data) {
	return haxe_crypto_Base64.encode(data);
};
var cloner_Cloner = function() {
	this.stringMapCloner = new cloner_MapCloner(this,haxe_ds_StringMap);
	this.intMapCloner = new cloner_MapCloner(this,haxe_ds_IntMap);
	this.classHandles = new haxe_ds_StringMap();
	this.classHandles.h["String"] = $bind(this,this.returnString);
	this.classHandles.h["Array"] = $bind(this,this.cloneArray);
	this.classHandles.h["haxe.ds.StringMap"] = ($_=this.stringMapCloner,$bind($_,$_.clone));
	this.classHandles.h["haxe.ds.IntMap"] = ($_=this.intMapCloner,$bind($_,$_.clone));
};
cloner_Cloner.__name__ = "cloner.Cloner";
cloner_Cloner.prototype = {
	returnString: function(v) {
		return v;
	}
	,clone: function(v) {
		this.cache = new haxe_ds_ObjectMap();
		var outcome = this._clone(v);
		this.cache = null;
		return outcome;
	}
	,_clone: function(v) {
		if(typeof(v) == "string") {
			return v;
		}
		if(v.__name__ != null) {
			return v;
		}
		var _g = Type.typeof(v);
		switch(_g._hx_index) {
		case 0:
			return null;
		case 1:
			return v;
		case 2:
			return v;
		case 3:
			return v;
		case 4:
			return this.handleAnonymous(v);
		case 5:
			return null;
		case 6:
			var c = _g.c;
			if(this.cache.h.__keys__[v.__id__] == null) {
				this.cache.set(v,this.handleClass(c,v));
			}
			return this.cache.h[v.__id__];
		case 7:
			var e = _g.e;
			return v;
		case 8:
			return null;
		}
	}
	,handleAnonymous: function(v) {
		var properties = Reflect.fields(v);
		var anonymous = { };
		var _g = 0;
		var _g1 = properties.length;
		while(_g < _g1) {
			var i = _g++;
			var property = properties[i];
			anonymous[property] = this._clone(Reflect.getProperty(v,property));
		}
		return anonymous;
	}
	,handleClass: function(c,inValue) {
		var this1 = this.classHandles;
		var key = c.__name__;
		var handle = this1.h[key];
		if(handle == null) {
			handle = $bind(this,this.cloneClass);
		}
		return handle(inValue);
	}
	,cloneArray: function(inValue) {
		var array = inValue.slice();
		var _g = 0;
		var _g1 = array.length;
		while(_g < _g1) {
			var i = _g++;
			array[i] = this._clone(array[i]);
		}
		return array;
	}
	,cloneClass: function(inValue) {
		var outValue = Object.create(js_Boot.getClass(inValue).prototype);
		var fields = Reflect.fields(inValue);
		var _g = 0;
		var _g1 = fields.length;
		while(_g < _g1) {
			var i = _g++;
			var field = fields[i];
			var property = Reflect.getProperty(inValue,field);
			outValue[field] = this._clone(property);
		}
		return outValue;
	}
	,__class__: cloner_Cloner
};
var cloner_MapCloner = function(cloner,type) {
	this.cloner = cloner;
	this.type = type;
	this.noArgs = [];
};
cloner_MapCloner.__name__ = "cloner.MapCloner";
cloner_MapCloner.prototype = {
	clone: function(inValue) {
		var inMap = inValue;
		var map = Type.createInstance(this.type,this.noArgs);
		var key = inMap.keys();
		while(key.hasNext()) {
			var key1 = key.next();
			map.set(key1,this.cloner._clone(inMap.get(key1)));
		}
		return map;
	}
	,__class__: cloner_MapCloner
};
var haxe_IMap = function() { };
haxe_IMap.__name__ = "haxe.IMap";
haxe_IMap.__isInterface__ = true;
haxe_IMap.prototype = {
	__class__: haxe_IMap
};
var haxe_Exception = function(message,previous,native) {
	Error.call(this,message);
	this.message = message;
	this.__previousException = previous;
	this.__nativeException = native != null ? native : this;
};
haxe_Exception.__name__ = "haxe.Exception";
haxe_Exception.caught = function(value) {
	if(((value) instanceof haxe_Exception)) {
		return value;
	} else if(((value) instanceof Error)) {
		return new haxe_Exception(value.message,null,value);
	} else {
		return new haxe_ValueException(value,null,value);
	}
};
haxe_Exception.thrown = function(value) {
	if(((value) instanceof haxe_Exception)) {
		return value.get_native();
	} else if(((value) instanceof Error)) {
		return value;
	} else {
		var e = new haxe_ValueException(value);
		return e;
	}
};
haxe_Exception.__super__ = Error;
haxe_Exception.prototype = $extend(Error.prototype,{
	unwrap: function() {
		return this.__nativeException;
	}
	,get_native: function() {
		return this.__nativeException;
	}
	,__class__: haxe_Exception
	,__properties__: {get_native:"get_native"}
});
var haxe_ValueException = function(value,previous,native) {
	haxe_Exception.call(this,String(value),previous,native);
	this.value = value;
};
haxe_ValueException.__name__ = "haxe.ValueException";
haxe_ValueException.__super__ = haxe_Exception;
haxe_ValueException.prototype = $extend(haxe_Exception.prototype,{
	unwrap: function() {
		return this.value;
	}
	,__class__: haxe_ValueException
});
var haxe_io_Bytes = function(data) {
	this.length = data.byteLength;
	this.b = new Uint8Array(data);
	this.b.bufferValue = data;
	data.hxBytes = this;
	data.bytes = this.b;
};
haxe_io_Bytes.__name__ = "haxe.io.Bytes";
haxe_io_Bytes.ofString = function(s,encoding) {
	if(encoding == haxe_io_Encoding.RawNative) {
		var buf = new Uint8Array(s.length << 1);
		var _g = 0;
		var _g1 = s.length;
		while(_g < _g1) {
			var i = _g++;
			var c = s.charCodeAt(i);
			buf[i << 1] = c & 255;
			buf[i << 1 | 1] = c >> 8;
		}
		return new haxe_io_Bytes(buf.buffer);
	}
	var a = [];
	var i = 0;
	while(i < s.length) {
		var c = s.charCodeAt(i++);
		if(55296 <= c && c <= 56319) {
			c = c - 55232 << 10 | s.charCodeAt(i++) & 1023;
		}
		if(c <= 127) {
			a.push(c);
		} else if(c <= 2047) {
			a.push(192 | c >> 6);
			a.push(128 | c & 63);
		} else if(c <= 65535) {
			a.push(224 | c >> 12);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		} else {
			a.push(240 | c >> 18);
			a.push(128 | c >> 12 & 63);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		}
	}
	return new haxe_io_Bytes(new Uint8Array(a).buffer);
};
haxe_io_Bytes.ofData = function(b) {
	var hb = b.hxBytes;
	if(hb != null) {
		return hb;
	}
	return new haxe_io_Bytes(b);
};
haxe_io_Bytes.prototype = {
	getString: function(pos,len,encoding) {
		if(pos < 0 || len < 0 || pos + len > this.length) {
			throw haxe_Exception.thrown(haxe_io_Error.OutsideBounds);
		}
		if(encoding == null) {
			encoding = haxe_io_Encoding.UTF8;
		}
		var s = "";
		var b = this.b;
		var i = pos;
		var max = pos + len;
		switch(encoding._hx_index) {
		case 0:
			var debug = pos > 0;
			while(i < max) {
				var c = b[i++];
				if(c < 128) {
					if(c == 0) {
						break;
					}
					s += String.fromCodePoint(c);
				} else if(c < 224) {
					var code = (c & 63) << 6 | b[i++] & 127;
					s += String.fromCodePoint(code);
				} else if(c < 240) {
					var c2 = b[i++];
					var code1 = (c & 31) << 12 | (c2 & 127) << 6 | b[i++] & 127;
					s += String.fromCodePoint(code1);
				} else {
					var c21 = b[i++];
					var c3 = b[i++];
					var u = (c & 15) << 18 | (c21 & 127) << 12 | (c3 & 127) << 6 | b[i++] & 127;
					s += String.fromCodePoint(u);
				}
			}
			break;
		case 1:
			while(i < max) {
				var c = b[i++] | b[i++] << 8;
				s += String.fromCodePoint(c);
			}
			break;
		}
		return s;
	}
	,toString: function() {
		return this.getString(0,this.length);
	}
	,__class__: haxe_io_Bytes
};
var haxe_io_Encoding = $hxEnums["haxe.io.Encoding"] = { __ename__:true,__constructs__:null
	,UTF8: {_hx_name:"UTF8",_hx_index:0,__enum__:"haxe.io.Encoding",toString:$estr}
	,RawNative: {_hx_name:"RawNative",_hx_index:1,__enum__:"haxe.io.Encoding",toString:$estr}
};
haxe_io_Encoding.__constructs__ = [haxe_io_Encoding.UTF8,haxe_io_Encoding.RawNative];
var haxe_crypto_Base64 = function() { };
haxe_crypto_Base64.__name__ = "haxe.crypto.Base64";
haxe_crypto_Base64.encode = function(bytes,complement) {
	if(complement == null) {
		complement = true;
	}
	var str = new haxe_crypto_BaseCode(haxe_crypto_Base64.BYTES).encodeBytes(bytes).toString();
	if(complement) {
		switch(bytes.length % 3) {
		case 1:
			str += "==";
			break;
		case 2:
			str += "=";
			break;
		default:
		}
	}
	return str;
};
haxe_crypto_Base64.decode = function(str,complement) {
	if(complement == null) {
		complement = true;
	}
	if(complement) {
		while(HxOverrides.cca(str,str.length - 1) == 61) str = HxOverrides.substr(str,0,-1);
	}
	return new haxe_crypto_BaseCode(haxe_crypto_Base64.BYTES).decodeBytes(haxe_io_Bytes.ofString(str));
};
var haxe_crypto_BaseCode = function(base) {
	var len = base.length;
	var nbits = 1;
	while(len > 1 << nbits) ++nbits;
	if(nbits > 8 || len != 1 << nbits) {
		throw haxe_Exception.thrown("BaseCode : base length must be a power of two.");
	}
	this.base = base;
	this.nbits = nbits;
};
haxe_crypto_BaseCode.__name__ = "haxe.crypto.BaseCode";
haxe_crypto_BaseCode.prototype = {
	encodeBytes: function(b) {
		var nbits = this.nbits;
		var base = this.base;
		var size = b.length * 8 / nbits | 0;
		var out = new haxe_io_Bytes(new ArrayBuffer(size + (b.length * 8 % nbits == 0 ? 0 : 1)));
		var buf = 0;
		var curbits = 0;
		var mask = (1 << nbits) - 1;
		var pin = 0;
		var pout = 0;
		while(pout < size) {
			while(curbits < nbits) {
				curbits += 8;
				buf <<= 8;
				buf |= b.b[pin++];
			}
			curbits -= nbits;
			out.b[pout++] = base.b[buf >> curbits & mask];
		}
		if(curbits > 0) {
			out.b[pout++] = base.b[buf << nbits - curbits & mask];
		}
		return out;
	}
	,initTable: function() {
		var tbl = [];
		var _g = 0;
		while(_g < 256) {
			var i = _g++;
			tbl[i] = -1;
		}
		var _g = 0;
		var _g1 = this.base.length;
		while(_g < _g1) {
			var i = _g++;
			tbl[this.base.b[i]] = i;
		}
		this.tbl = tbl;
	}
	,decodeBytes: function(b) {
		var nbits = this.nbits;
		var base = this.base;
		if(this.tbl == null) {
			this.initTable();
		}
		var tbl = this.tbl;
		var size = b.length * nbits >> 3;
		var out = new haxe_io_Bytes(new ArrayBuffer(size));
		var buf = 0;
		var curbits = 0;
		var pin = 0;
		var pout = 0;
		while(pout < size) {
			while(curbits < 8) {
				curbits += nbits;
				buf <<= nbits;
				var i = tbl[b.b[pin++]];
				if(i == -1) {
					throw haxe_Exception.thrown("BaseCode : invalid encoded char");
				}
				buf |= i;
			}
			curbits -= 8;
			out.b[pout++] = buf >> curbits & 255;
		}
		return out;
	}
	,__class__: haxe_crypto_BaseCode
};
var haxe_ds_IntMap = function() {
	this.h = { };
};
haxe_ds_IntMap.__name__ = "haxe.ds.IntMap";
haxe_ds_IntMap.__interfaces__ = [haxe_IMap];
haxe_ds_IntMap.prototype = {
	set: function(key,value) {
		this.h[key] = value;
	}
	,get: function(key) {
		return this.h[key];
	}
	,keys: function() {
		var a = [];
		for( var key in this.h ) if(this.h.hasOwnProperty(key)) a.push(+key);
		return new haxe_iterators_ArrayIterator(a);
	}
	,__class__: haxe_ds_IntMap
};
var haxe_ds_ObjectMap = function() {
	this.h = { __keys__ : { }};
};
haxe_ds_ObjectMap.__name__ = "haxe.ds.ObjectMap";
haxe_ds_ObjectMap.__interfaces__ = [haxe_IMap];
haxe_ds_ObjectMap.prototype = {
	set: function(key,value) {
		var id = key.__id__;
		if(id == null) {
			id = (key.__id__ = $global.$haxeUID++);
		}
		this.h[id] = value;
		this.h.__keys__[id] = key;
	}
	,get: function(key) {
		return this.h[key.__id__];
	}
	,keys: function() {
		var a = [];
		for( var key in this.h.__keys__ ) {
		if(this.h.hasOwnProperty(key)) {
			a.push(this.h.__keys__[key]);
		}
		}
		return new haxe_iterators_ArrayIterator(a);
	}
	,__class__: haxe_ds_ObjectMap
};
var haxe_ds_StringMap = function() {
	this.h = Object.create(null);
};
haxe_ds_StringMap.__name__ = "haxe.ds.StringMap";
haxe_ds_StringMap.__interfaces__ = [haxe_IMap];
haxe_ds_StringMap.prototype = {
	get: function(key) {
		return this.h[key];
	}
	,set: function(key,value) {
		this.h[key] = value;
	}
	,keys: function() {
		return new haxe_ds__$StringMap_StringMapKeyIterator(this.h);
	}
	,__class__: haxe_ds_StringMap
};
var haxe_ds__$StringMap_StringMapKeyIterator = function(h) {
	this.h = h;
	this.keys = Object.keys(h);
	this.length = this.keys.length;
	this.current = 0;
};
haxe_ds__$StringMap_StringMapKeyIterator.__name__ = "haxe.ds._StringMap.StringMapKeyIterator";
haxe_ds__$StringMap_StringMapKeyIterator.prototype = {
	hasNext: function() {
		return this.current < this.length;
	}
	,next: function() {
		return this.keys[this.current++];
	}
	,__class__: haxe_ds__$StringMap_StringMapKeyIterator
};
var haxe_http_HttpBase = function(url) {
	this.url = url;
	this.headers = [];
	this.params = [];
	this.emptyOnData = $bind(this,this.onData);
};
haxe_http_HttpBase.__name__ = "haxe.http.HttpBase";
haxe_http_HttpBase.prototype = {
	addHeader: function(header,value) {
		this.headers.push({ name : header, value : value});
	}
	,setPostData: function(data) {
		this.postData = data;
		this.postBytes = null;
	}
	,onData: function(data) {
	}
	,onBytes: function(data) {
	}
	,onError: function(msg) {
	}
	,onStatus: function(status) {
	}
	,hasOnData: function() {
		return !Reflect.compareMethods($bind(this,this.onData),this.emptyOnData);
	}
	,success: function(data) {
		this.responseBytes = data;
		this.responseAsString = null;
		if(this.hasOnData()) {
			this.onData(this.get_responseData());
		}
		this.onBytes(this.responseBytes);
	}
	,get_responseData: function() {
		if(this.responseAsString == null && this.responseBytes != null) {
			this.responseAsString = this.responseBytes.getString(0,this.responseBytes.length,haxe_io_Encoding.UTF8);
		}
		return this.responseAsString;
	}
	,__class__: haxe_http_HttpBase
	,__properties__: {get_responseData:"get_responseData"}
};
var haxe_http_HttpJs = function(url) {
	this.async = true;
	this.withCredentials = false;
	haxe_http_HttpBase.call(this,url);
};
haxe_http_HttpJs.__name__ = "haxe.http.HttpJs";
haxe_http_HttpJs.__super__ = haxe_http_HttpBase;
haxe_http_HttpJs.prototype = $extend(haxe_http_HttpBase.prototype,{
	request: function(post) {
		var _gthis = this;
		this.responseAsString = null;
		this.responseBytes = null;
		var r = this.req = js_Browser.createXMLHttpRequest();
		var onreadystatechange = function(_) {
			if(r.readyState != 4) {
				return;
			}
			var s;
			try {
				s = r.status;
			} catch( _g ) {
				s = null;
			}
			if(s == 0 && js_Browser.get_supported() && $global.location != null) {
				var protocol = $global.location.protocol.toLowerCase();
				var rlocalProtocol = new EReg("^(?:about|app|app-storage|.+-extension|file|res|widget):$","");
				var isLocal = rlocalProtocol.match(protocol);
				if(isLocal) {
					s = r.response != null ? 200 : 404;
				}
			}
			if(s == undefined) {
				s = null;
			}
			if(s != null) {
				_gthis.onStatus(s);
			}
			if(s != null && s >= 200 && s < 400) {
				_gthis.req = null;
				_gthis.success(haxe_io_Bytes.ofData(r.response));
			} else if(s == null || s == 0 && r.response == null) {
				_gthis.req = null;
				_gthis.onError("Failed to connect or resolve host");
			} else if(s == null) {
				_gthis.req = null;
				var onreadystatechange = r.response != null ? haxe_io_Bytes.ofData(r.response) : null;
				_gthis.responseBytes = onreadystatechange;
				_gthis.onError("Http Error #" + r.status);
			} else {
				switch(s) {
				case 12007:
					_gthis.req = null;
					_gthis.onError("Unknown host");
					break;
				case 12029:
					_gthis.req = null;
					_gthis.onError("Failed to connect to host");
					break;
				default:
					_gthis.req = null;
					var onreadystatechange = r.response != null ? haxe_io_Bytes.ofData(r.response) : null;
					_gthis.responseBytes = onreadystatechange;
					_gthis.onError("Http Error #" + r.status);
				}
			}
		};
		if(this.async) {
			r.onreadystatechange = onreadystatechange;
		}
		var uri;
		var _g = this.postData;
		var _g1 = this.postBytes;
		if(_g == null) {
			if(_g1 == null) {
				uri = null;
			} else {
				var bytes = _g1;
				uri = new Blob([bytes.b.bufferValue]);
			}
		} else if(_g1 == null) {
			var str = _g;
			uri = str;
		} else {
			uri = null;
		}
		if(uri != null) {
			post = true;
		} else {
			var _g = 0;
			var _g1 = this.params;
			while(_g < _g1.length) {
				var p = _g1[_g];
				++_g;
				if(uri == null) {
					uri = "";
				} else {
					uri = (uri == null ? "null" : Std.string(uri)) + "&";
				}
				var s = p.name;
				var value = (uri == null ? "null" : Std.string(uri)) + encodeURIComponent(s) + "=";
				var s1 = p.value;
				uri = value + encodeURIComponent(s1);
			}
		}
		try {
			if(post) {
				r.open("POST",this.url,this.async);
			} else if(uri != null) {
				var question = this.url.split("?").length <= 1;
				r.open("GET",this.url + (question ? "?" : "&") + (uri == null ? "null" : Std.string(uri)),this.async);
				uri = null;
			} else {
				r.open("GET",this.url,this.async);
			}
			r.responseType = "arraybuffer";
		} catch( _g ) {
			var e = haxe_Exception.caught(_g).unwrap();
			this.req = null;
			this.onError(e.toString());
			return;
		}
		r.withCredentials = this.withCredentials;
		if(!Lambda.exists(this.headers,function(h) {
			return h.name == "Content-Type";
		}) && post && this.postData == null) {
			r.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		}
		var _g = 0;
		var _g1 = this.headers;
		while(_g < _g1.length) {
			var h = _g1[_g];
			++_g;
			r.setRequestHeader(h.name,h.value);
		}
		r.send(uri);
		if(!this.async) {
			onreadystatechange(null);
		}
	}
	,__class__: haxe_http_HttpJs
});
var haxe_io_Error = $hxEnums["haxe.io.Error"] = { __ename__:true,__constructs__:null
	,Blocked: {_hx_name:"Blocked",_hx_index:0,__enum__:"haxe.io.Error",toString:$estr}
	,Overflow: {_hx_name:"Overflow",_hx_index:1,__enum__:"haxe.io.Error",toString:$estr}
	,OutsideBounds: {_hx_name:"OutsideBounds",_hx_index:2,__enum__:"haxe.io.Error",toString:$estr}
	,Custom: ($_=function(e) { return {_hx_index:3,e:e,__enum__:"haxe.io.Error",toString:$estr}; },$_._hx_name="Custom",$_.__params__ = ["e"],$_)
};
haxe_io_Error.__constructs__ = [haxe_io_Error.Blocked,haxe_io_Error.Overflow,haxe_io_Error.OutsideBounds,haxe_io_Error.Custom];
var haxe_iterators_ArrayIterator = function(array) {
	this.current = 0;
	this.array = array;
};
haxe_iterators_ArrayIterator.__name__ = "haxe.iterators.ArrayIterator";
haxe_iterators_ArrayIterator.prototype = {
	hasNext: function() {
		return this.current < this.array.length;
	}
	,next: function() {
		return this.array[this.current++];
	}
	,__class__: haxe_iterators_ArrayIterator
};
var host_App = function() { };
host_App.__name__ = "host.App";
host_App.__interfaces__ = [hxasync_Asyncable];
host_App.init = function(v) {
	host_App.docker = v;
	var req = new haxe_http_HttpJs("http://localhost.tech:7860/");
	req.onData = function(data_out) {
		var gradio_props = JSON.parse(data_out.split("<script>window.gradio_config = ")[1].split(";</script>")[0]);
		host_App.gradio_components = gradio_props["components"];
		host_App.gradio_components.sort(function(a,b) {
			return a["id"] - b["id"] | 0;
		});
		var _g = 0;
		var _g1 = host_App.gradio_components;
		while(_g < _g1.length) {
			var component = _g1[_g];
			++_g;
			var comp = component;
			var props = comp["props"];
			if(props["elem_id"] == "txt2img_generate") {
				host_UI.txt2img_generate_fn_index = comp["id"];
			}
		}
		var dep = null;
		var dependencies = gradio_props["dependencies"];
		var _g = 0;
		var _g1 = dependencies.length;
		while(_g < _g1) {
			var i = _g++;
			dep = dependencies[i];
			if(dep["targets"][0] == host_UI.txt2img_generate_fn_index) {
				host_UI.txt2img_data_inputs = dep["inputs"];
				host_UI.txt2img_data_outputs = dep["outputs"];
				host_UI.txt2img_generate_fn_index = i;
				break;
			}
		}
		var _g = 0;
		var _g1 = host_UI.txt2img_data_inputs;
		while(_g < _g1.length) {
			var id = _g1[_g];
			++_g;
			var tmp = host_UI.tags.h["txt2img"];
			var _g2 = [];
			var _g3 = 0;
			var _g4 = host_App.gradio_components;
			while(_g3 < _g4.length) {
				var v = _g4[_g3];
				++_g3;
				if(v["id"] == id) {
					_g2.push(v);
				}
			}
			tmp.push(_g2[0]);
		}
		var _g = 0;
		var _g1 = host_UI.txt2img_data_outputs;
		while(_g < _g1.length) {
			var id = _g1[_g];
			++_g;
			var tmp = host_UI.tags.h["txt2img"];
			var _g2 = [];
			var _g3 = 0;
			var _g4 = host_App.gradio_components;
			while(_g3 < _g4.length) {
				var v = _g4[_g3];
				++_g3;
				if(v["id"] == id) {
					_g2.push(v);
				}
			}
			tmp.push(_g2[0]);
		}
		console.log("src/host/App.hx:92:",host_UI.tags.h["txt2img"]);
		var _g = 0;
		var _g1 = host_App.gradio_components;
		while(_g < _g1.length) {
			var component = _g1[_g];
			++_g;
			var comp = component;
			var props = comp["props"];
			if(props["elem_id"] == "img2img_generate") {
				host_UI.img2img_generate_fn_index = comp["id"];
				console.log("src/host/App.hx:102:",comp);
			}
		}
		var dep = null;
		host_App.gradio_dependencies = gradio_props["dependencies"];
		var _g = 0;
		var _g1 = host_App.gradio_dependencies.length;
		while(_g < _g1) {
			var i = _g++;
			dep = host_App.gradio_dependencies[i];
			if(dep["targets"][0] == host_UI.img2img_generate_fn_index) {
				host_UI.img2img_data_inputs = dep["inputs"];
				host_UI.img2img_data_outputs = dep["outputs"];
				host_UI.img2img_generate_fn_index = i;
				break;
			}
		}
		var _g = 0;
		var _g1 = host_UI.img2img_data_inputs;
		while(_g < _g1.length) {
			var id = _g1[_g];
			++_g;
			var tmp = host_UI.tags.h["img2img"];
			var _g2 = [];
			var _g3 = 0;
			var _g4 = host_App.gradio_components;
			while(_g3 < _g4.length) {
				var v = _g4[_g3];
				++_g3;
				if(v["id"] == id) {
					_g2.push(v);
				}
			}
			tmp.push(_g2[0]);
		}
		var _g = 0;
		var _g1 = host_UI.img2img_data_outputs;
		while(_g < _g1.length) {
			var id = _g1[_g];
			++_g;
			var tmp = host_UI.tags.h["img2img"];
			var _g2 = [];
			var _g3 = 0;
			var _g4 = host_App.gradio_components;
			while(_g3 < _g4.length) {
				var v = _g4[_g3];
				++_g3;
				if(v["id"] == id) {
					_g2.push(v);
				}
			}
			tmp.push(_g2[0]);
		}
		console.log("src/host/App.hx:134:",host_UI.tags.h["img2img"]);
		host_UI.createInterface();
	};
	req.request(false);
};
host_App.getDocumentState = async function() {
	return host_Image.getDocumentState();
};
host_App.setDocumentState = async function(state) {
	await host_Image.setDocumentState(state);
};
host_App.setLayerName = function(layer,layer_name) {
	host_Image.setLayerName(layer.id,layer_name);
};
var host_Docker_myDocker = null;
var host_Image = function() { };
host_Image.__name__ = "host.Image";
host_Image.__interfaces__ = [hxasync_Asyncable];
host_Image.pngFromLayer = async function(layer,transparency) {
	if(transparency == null) {
		transparency = true;
	}
	try {
		await host_Image.writeLayerToDisk(layer.id,transparency);
	} catch( _g ) {
		var e = haxe_Exception.caught(_g);
		console.log("src/host/Image.js.hx:19:",e);
	}
	var bytes = await host_Image.readBytesFromDisk("layerbuf" + layer.id);
	return bytes;
};
host_Image.pngFromSelection_SingleLayer = async function(selection,layer) {
	var hist = require("photoshop").app.activeDocument.activeHistoryState;
	var state = await host_Image.getDocumentState();
	state.selection = selection;
	await host_Image.setDocumentState(state);
	await require("photoshop").core.executeAsModal( async () => {await require("photoshop").action.batchPlay(
         [
            {"_obj":"crop","delete":true}
        ],{
            synchronousExecution: true,
            modalBehavior: "execute"
         })});
      ;
	var png = await host_Image.pngFromLayer(layer,false);
	await require("photoshop").core.executeAsModal( async () => {require("photoshop").app.activeDocument.activeHistoryState = hist});
	return png;
};
host_Image.pngFromSelection = async function(selection,layer) {
	if(layer != null) {
		return host_Image.pngFromSelection_SingleLayer(selection,layer);
	}
	var hist = require("photoshop").app.activeDocument.activeHistoryState;
	var state = await host_Image.getDocumentState();
	state.selection = selection;
	await host_Image.setDocumentState(state);
	await require("photoshop").core.executeAsModal( async () => {await require("photoshop").action.batchPlay(
                [
                {"_obj":"crop","delete":true},

                {"_obj":"copyMerged"},
                {"_obj":"paste","antiAlias":{"_enum":"antiAliasType","_value":"antiAliasNone"},"as":{"_class":"pixel"}}
                ],{
                synchronousExecution: true,
                modalBehavior: "execute"
                })});
                ;
	var png = null;
	try {
		var state = await host_Image.getDocumentState();
		var layer = state.layer;
		png = await host_Image.pngFromLayer(layer);
	} catch( _g ) {
		var e = haxe_Exception.caught(_g);
		console.log("src/host/Image.js.hx:79:",e);
	}
	await require("photoshop").core.executeAsModal( async () => {require("photoshop").app.activeDocument.activeHistoryState = hist});
	return png;
};
host_Image.layerFromPng = async function(png,layer_name) {
	if(layer_name == null) {
		layer_name = "SD";
	}
	await host_Image.writeBytesToDisk(png,layer_name);
	await host_Image.loadFileAsLayer(layer_name);
	host_Image.setLayerName(1,layer_name);
};
host_Image.setLayerName = async function(id,layer_name) {
	await require("photoshop").core.executeAsModal(async () => {await require("photoshop").action.batchPlay(
            [
               {
                  _obj: "set",
                  _target: [
                     {
                        _ref: "layer",
                        _enum: "ordinal",
                        _value: "targetEnum"
                     }
                  ],
                  to: {
                     _obj: "layer",
                     name: layer_name
                  },
                  _options: {
                     dialogOptions: "dontDisplay"
                  }
               }
            ],{
               synchronousExecution: true,
               modalBehavior: "execute"
            });});
            ;
};
host_Image.getLayerIndex = function(layer_id) {
	var layers = require('photoshop').app.activeDocument.layers;
	var _g = 0;
	var _g1 = layers.length - 1;
	while(_g < _g1) {
		var i = _g++;
		if(layers[i]._id == "" + layer_id) {
			return "" + (layers.length - 1 - i);
		}
	}
	return "" + 1;
};
host_Image.layerByName = function(layername) {
	var layers = require('photoshop').app.activeDocument.layers;
	var _g = 0;
	var _g1 = layers.length - 1;
	while(_g < _g1) {
		var i = _g++;
		if(layers[i].name == layername) {
			return layers[i];
		}
	}
	return null;
};
host_Image.special_fillBk_screen = async function(selection) {
	var result;
      var psAction = require("photoshop").action;
  
      var command = [         
          // Reset Swatches
          {"_obj":"reset","_target":[{"_property":"colors","_ref":"color"}]},
          // Fill
          {"_obj":"fill","antiAlias":true,"from":{"_obj":"paint","horizontal":{"_unit":"pixelsUnit","_value":selection.x+1},"vertical":{"_unit":"pixelsUnit","_value":selection.y+1}},"tolerance":32,"using":{"_enum":"fillContents","_value":"foregroundColor"}},
          // Select brush
          {"_obj":"select","_target":[{"_ref":"paintbrushTool"}]},
          // Exchange Swatches
          {"_obj":"exchange","_target":[{"_property":"colors","_ref":"color"}]},
          // Set current layer
          {"_obj":"set","_target":[{"_enum":"ordinal","_ref":"layer","_value":"targetEnum"}],"to":{"_obj":"layer","mode":{"_enum":"blendMode","_value":"screen"}}
            }
      ];
      result = await require("photoshop").core.executeAsModal(async() => {await psAction.batchPlay(command, {});});
      ;
};
host_Image.writeLayerToDisk = async function(layer_id,transparency) {
	if(transparency == null) {
		transparency = true;
	}
	var state = host_Image.getDocumentState();
	if(state.selection == null) {
		state.selection = { x : 0, y : 0, width : 512, height : 512};
		host_Image.setDocumentState(state);
	}
	var layer_index = host_Image.getLayerIndex(layer_id);
	const docid = require("photoshop").app.activeDocument._id;
        var tfold = await require("uxp").storage.localFileSystem.getTemporaryFolder()
        const path = tfold.nativePath + "\\layerbuf"+layer_id+".png";
        var properties = {eventLevel: 0, 
          documentID: docid, 
          exportPath: path, 
          exportOptions: {
          scaleHorizontal: 100, 
          scaleVertical: 100, 
          canvasSize: {width: state.selection.width, height: state.selection.height
          }, 
          exportConvertToSRGB: true, 
          transparency: transparency, 
          layers : ""+layer_index   //THIS IS AN INDEX, NOT AN ID!
          }, 
          formatOptions: {name: "png", 
              metadata: "none", 
              embedProfiles: true, 
              colorType: "png32", 
              ICCColorProfile: "sRGB IEC61966-2.1"}
          };
            await require("photoshop").exportmanager.exportImageAsync(properties);
        ;
};
host_Image.readBytesFromDisk = async function(fname) {
	var foo = async () => {
            const folder = await require('uxp').storage.localFileSystem.getTemporaryFolder();
            const myFile = await folder.getEntry(''+fname+'.png');
            return await myFile.read( {format: require('uxp').storage.formats.binary});
        };
	return foo();
};
host_Image.writeBytesToDisk = async function(bytes,fname) {
	if(fname == null) {
		fname = "out";
	}
	const folder = await require('uxp').storage.localFileSystem.getTemporaryFolder();
            try {
            const oldfile = await folder.getEntry(''+fname+'.png');
            await oldfile.delete();
            }catch (error) {}
            const myFile = await folder.createFile(''+fname+'.png');
            console.log(await myFile.write(bytes, {format: require('uxp').storage.formats.binary}));
            console.log('written bytes to disk');
            ;
};
host_Image.loadFileAsLayer = async function(fname) {
	await host_Image.createLayer("buffer");
	var state = await host_Image.getDocumentState();
	     
        try{
            var folder = await require("uxp").storage.localFileSystem.getTemporaryFolder();
            var file = await folder.getEntry(""+fname+".png");
            var path = await require("uxp").storage.localFileSystem.createSessionToken(file);
        }catch (e){
            console.error(e);
        }
        try{
        var properties = {
            _obj: "placeEvent",
            ID: 10,
            null: {
               _path: path,
               _kind: "local"
            },
            freeTransformCenterState: {
               _enum: "quadCenterState",
               _value: "QCSAverage"
            },
            offset: {
               _obj: "offset",
               horizontal: {
                  _unit: "pixelsUnit",
                  _value: 0
               },
               vertical: {
                  _unit: "pixelsUnit",
                  _value: 0
               }
            },
            width: {
               _unit: "pixelsUnit",
               _value: 50
            },
            height: {
               _unit: "pixelsUnit",
               _value: 50
            },
            replaceLayer: {
               _obj: "placeEvent",
               to: {
                  _ref: "layer",
                  _id: 226
               }
            },
            _options: {
               dialogOptions: "dontDisplay"
            }
         };
        var foo = async () =>{ await require("photoshop").action.batchPlay([
            properties,
            {
            _obj: "placedLayerResetTransforms",
            _options: {
                dialogOptions: "dontDisplay"
                }
            }
        ],{})};  //lol  
            await require("photoshop").core.executeAsModal(foo, {commandName : "load png"});
        }   catch (e){
            console.error(e);
        }

        ;
	await host_Image.setDocumentState(state);
};
host_Image.getDocumentState = async function() {
	let props = {
            _obj: 'get',
            _target: [
              { _property: 'selection' },
              {
                _ref: 'document',
                _enum: 'ordinal',
                _value: 'targetEnum',
              },
            ],
            _options: { dialogOptions: 'dontDisplay' },
          };
        ;
	var ps_sel = await require('photoshop').action.batchPlay([props], {});
	var statesel = null;
	if(ps_sel[0].selection != null) {
		statesel = { x : ps_sel[0].selection.left._value, y : ps_sel[0].selection.top._value, width : ps_sel[0].selection.right._value - ps_sel[0].selection.left._value, height : ps_sel[0].selection.bottom._value - ps_sel[0].selection.top._value};
	}
	var statelayer = host_Image.getSelectedLayer();
	var state = { document : null, layer : host_Image.getSelectedLayer(), selection : statesel};
	return state;
};
host_Image.deselect = async function() {
	await require("photoshop").core.executeAsModal( async () => {await require("photoshop").action.batchPlay(
            [
               {
                  _obj: "set",
                  _target: [
                     {
                        _ref: "channel",
                        _property: "selection"
                     }
                  ],
                  to: {
                     _enum: "ordinal",
                     _value: "none"
                  },
                  _options: {
                     dialogOptions: "dontDisplay"
                  }
               }
            ],{
               synchronousExecution: true,
               modalBehavior: "execute"
            })});
            ;
};
host_Image.setDocumentState = async function(state) {
	var sel = state.selection;
	var bottom = sel.y + sel.height;
	var right = sel.x + sel.width;
	await require("photoshop").core.executeAsModal( async () => {await require("photoshop").action.batchPlay(
            [
               {
                  _obj: "set",
                  _target: [
                     {
                        _ref: "channel",
                        _property: "selection"
                     }
                  ],
                  to: {
                     _obj: "rectangle",
                     top: {
                        _unit: "pixelsUnit",
                        _value: sel.y
                     },
                     left: {
                        _unit: "pixelsUnit",
                        _value: sel.x
                     },
                     bottom: {
                        _unit: "pixelsUnit",
                        _value: bottom
                     },
                     right: {
                        _unit: "pixelsUnit",
                        _value: right
                     }
                  },
                  _options: {
                     dialogOptions: "dontDisplay"
                  }
               }
            ],{
               synchronousExecution: true,
               modalBehavior: "execute"
            })});
            ;
};
host_Image.createLayer = async function(layername,type) {
	try {
		await require("photoshop").core.executeAsModal( async () => {
            await require("photoshop").app.activeDocument.createLayer({ name: layername});
          } );
	} catch( _g ) {
		var e = haxe_Exception.caught(_g);
		console.log("src/host/Image.js.hx:417:",e);
	}
};
host_Image.getSelectedLayer = function() {
	var layer = null;
	try {
		layer = { _internal : require("photoshop").app.activeDocument.activeLayers[0], id : require("photoshop").app.activeDocument.activeLayers[0]._id, name : require("photoshop").app.activeDocument.activeLayers[0].name, visible : require("photoshop").app.activeDocument.activeLayers[0].visible};
	} catch( _g ) {
		var e = haxe_Exception.caught(_g);
		console.log("src/host/Image.js.hx:434:",e);
	}
	return layer;
};
function host_Image_init() {
}
var host_UI = function() { };
host_UI.__name__ = "host.UI";
host_UI.__interfaces__ = [hxasync_Asyncable];
host_UI.createInterface = function() {
	var cloner = new cloner_Cloner();
	var this1 = host_UI.tags;
	var v = cloner.clone(host_UI.tags.h["img2img"]);
	this1.h["inpaint"] = v;
	var this1 = host_UI.tags;
	var v = cloner.clone(host_UI.tags.h["img2img"]);
	this1.h["outpainting_mk2"] = v;
	var toaster = host_UI_doc.createElement("div");
	toaster.className = "toaster row";
	host_UI_doc.getElementById("docker").appendChild(toaster);
	var toast_icon = host_UI_doc.createElement("sp-label");
	toast_icon.innerHTML = "🍞:";
	toast_icon.className = "col-1 toaster-text";
	toaster.appendChild(toast_icon);
	var toast_text = host_UI_doc.createElement("label");
	toast_text.innerHTML = "\"high dpi screenshot of a crude UI, broken CSS, uneven scales, bad margins, digital art by Adobe, trending on 4chan\"";
	toast_text.className = "col-11 toaster-text";
	toast_text.id = "toast_text";
	toaster.appendChild(toast_text);
	var tabWidget = host_UI_doc.getElementById("tabs_widget");
	host_UI.makeTab("txt2img");
	host_UI.makeTab("img2img");
	host_UI.makeTab("inpaint");
	host_UI.makeTab("outpainting_mk2");
	host_UI.showTab("txt2img");
};
host_UI.makeTab = function(mode) {
	var tabWidget = host_UI_doc.getElementById("tabs_widget");
	var tab = host_UI_doc.createElement("div");
	tab.className = "sp-tab";
	tab.id = "tab-" + mode;
	var lab = host_UI_doc.createElement("sp-label");
	lab.innerHTML = mode;
	tab.appendChild(lab);
	tab.onclick = function(event) {
		host_UI.showTab(mode);
	};
	tabWidget.appendChild(tab);
	var page = host_UI_doc.createElement("div");
	page.className = "sp-tab-page";
	page.id = "page-" + mode;
	host_UI_doc.getElementById("docker").appendChild(page);
	var header = host_UI_doc.createElement("div");
	header.className = "row g-0 row-cols-12";
	page.appendChild(header);
	var btn_recycle = host_UI_doc.createElement("sp-button");
	btn_recycle.className = "col-auto";
	btn_recycle.textContent = "♻️";
	btn_recycle.addEventListener("click",function(event) {
		return host_UI.asyncfetch(host_UI.tags.h[mode]);
	});
	header.appendChild(btn_recycle);
	var btn_generate = host_UI_doc.createElement("sp-button");
	btn_generate.className = "col-7";
	btn_generate.textContent = "Generate";
	btn_generate.style.backgroundColor = "#fd7e14";
	btn_generate.addEventListener("click",function(event) {
		host_App.docker.generate2(mode,host_UI.tags.h[mode]);
	});
	header.appendChild(btn_generate);
	var bs_row = host_UI_doc.createElement("div");
	bs_row.className = "row g-0 row-cols-12";
	page.appendChild(bs_row);
	Utils.cleanTags(host_UI.tags.h[mode]);
	var _g = 0;
	var _g1 = host_UI.tags.h[mode];
	while(_g < _g1.length) {
		var comp = _g1[_g];
		++_g;
		var col = host_UI.makeComponent(comp,mode);
		bs_row.appendChild(col);
	}
	if(mode == "outpainting_mk2") {
		var scriptcomponent = null;
		var temp_props = null;
		var _g = 0;
		var _g1 = host_UI.tags.h["outpainting_mk2"];
		while(_g < _g1.length) {
			var tag = _g1[_g];
			++_g;
			temp_props = tag["props"];
			if(temp_props["param_name"] == "script") {
				scriptcomponent = tag;
			}
		}
		console.log("src/host/UI.js.hx:148:",scriptcomponent);
		scriptcomponent["setter"]("Outpainting mk2");
		var scriptdep = null;
		var fni = null;
		var _g = 0;
		var _g1 = host_App.gradio_dependencies.length;
		while(_g < _g1) {
			var i = _g++;
			if(host_App.gradio_dependencies[i]["targets"][0] == scriptcomponent["id"]) {
				fni = i;
			}
		}
		console.log("src/host/UI.js.hx:157:","Script dropdown fnid: " + fni);
		var outputs = host_App.gradio_dependencies[fni]["outputs"];
		var req = new haxe_http_HttpJs("http://localhost.tech:7860/api/predict");
		req.addHeader("Content-Type","application/json");
		var post_data = JSON.stringify({ fn_index : fni, data : ["Outpainting mk2"], session_hash : null});
		console.log("src/host/UI.js.hx:168:",post_data);
		req.setPostData(post_data);
		req.onData = function(data_out) {
			var vismap = [];
			var props = null;
			var _g = 0;
			var _g1 = host_UI.tags.h["outpainting_mk2"];
			while(_g < _g1.length) {
				var comp = _g1[_g];
				++_g;
				if(outputs.indexOf(comp["id"]) != -1) {
					vismap.push(comp);
				}
			}
			console.log("src/host/UI.js.hx:182:",vismap);
			var jdata = JSON.parse(data_out);
			var data = jdata["data"];
			console.log("src/host/UI.js.hx:185:",data);
			var tag_props = null;
			var _g = 0;
			var _g1 = data.length;
			while(_g < _g1) {
				var i = _g++;
				tag_props = vismap[i]["props"];
				tag_props["visible"] = data[i]["visible"];
				if(data[i]["visible"] && !tag_props["forcehidden"]) {
					(js_Boot.__cast(vismap[i]["container"] , HTMLElement)).style.display = "flex";
				} else {
					(js_Boot.__cast(vismap[i]["container"] , HTMLElement)).style.display = "none";
				}
			}
		};
		req.onStatus = function(status) {
			console.log("src/host/UI.js.hx:201:",status);
		};
		req.request(true);
	}
	tabWidget.appendChild(tab);
};
host_UI.asyncfetch = async function(components) {
	var layer = (await host_App.getDocumentState()).layer;
	if(layer == null) {
		host_UI.toast("Please select a layer to fetch from");
	} else {
		Utils.fetchAndInsert(layer,components);
	}
};
host_UI.toast = function(msg) {
	host_UI_doc.getElementById("toast_text").innerHTML = msg;
};
host_UI.showTab = function(mode) {
	var _g = 0;
	var _g1 = host_UI_doc.querySelectorAll(".sp-tab");
	while(_g < _g1.length) {
		var tab2 = _g1[_g];
		++_g;
		var tab21 = tab2;
		if(tab21.id == "tab-" + mode) {
			tab21.classList.add("selected");
		} else {
			tab21.classList.remove("selected");
		}
	}
	var _g = 0;
	var _g1 = host_UI_doc.querySelectorAll(".sp-tab-page");
	while(_g < _g1.length) {
		var page = _g1[_g];
		++_g;
		var page1 = page;
		if(page1.id == "page-" + mode) {
			page1.classList.add("visible");
		} else {
			page1.classList.remove("visible");
		}
	}
};
host_UI.makeComponent = function(component,mode) {
	var itype = component["type"];
	var props = component["props"];
	var groupbox = host_UI_doc.createElement("div");
	var label = host_UI_doc.createElement("sp-label");
	var param_name = props["param_name"];
	label.innerHTML = param_name;
	groupbox.appendChild(label);
	if(param_name == "extra") {
		props["value"] = true;
		props["visible"] = false;
	}
	if(param_name == "resize_mode") {
		props["visible"] = false;
	}
	if(param_name == "mask_mode") {
		props["choices"] = ["Upload mask"];
		props["value"] = "Upload mask";
		props["visible"] = false;
	}
	if((param_name == "mask_blur" || param_name == "masked_content" || param_name == "masking_mode" || param_name == "inpaint_at full resolution" || param_name == "inpaint_at full resolution padding, pixels") && mode != "inpaint") {
		props["visible"] = false;
	}
	if(param_name == "input_directory" || param_name == "output_directory") {
		props["visible"] = false;
	}
	var colsize = null;
	if(param_name == "height") {
		var getter = function() {
			return host_UI.gatherSpecialParameter("height");
		};
		component["getter"] = getter;
		props["visible"] = false;
	} else if(param_name == "width") {
		var getter1 = function() {
			return host_UI.gatherSpecialParameter("width");
		};
		component["getter"] = getter1;
		props["visible"] = false;
	} else if(itype == "image") {
		var getter2 = function() {
			return host_UI.gatherSpecialParameter(props["elem_id"]);
		};
		component["getter"] = getter2;
		props["visible"] = false;
	} else if(itype == "label") {
		var getter3 = function() {
			return host_UI.is_inpainting;
		};
		component["getter"] = getter3;
		props["visible"] = false;
	} else if(itype == "file" || itype == "html") {
		props["forcehidden"] = true;
		var getter4 = function() {
			return null;
		};
		component["getter"] = getter4;
		props["visible"] = false;
	} else if(itype == "gallery" || itype == "html") {
		var getter5 = function() {
			return "";
		};
		component["getter"] = getter5;
		props["visible"] = false;
	} else if(itype == "textbox") {
		colsize = "col-12";
		var input = host_UI_doc.createElement("sp-textarea");
		input.rows = props["lines"];
		input.multiline = true;
		input.className = "param" + mode + Std.string(param_name);
		input.value = props["value"];
		groupbox.appendChild(input);
		var getter6 = function() {
			return input.value;
		};
		var setter = function(val) {
			input.value = val;
		};
		component["getter"] = getter6;
		component["setter"] = setter;
	} else if(itype == "dropdown" || itype == "radio") {
		colsize = "col-3";
		var input1 = host_UI_doc.createElement("select");
		input1.className = "param" + mode + Std.string(param_name);
		host_UI.addOptions(input1,props["choices"]);
		input1.value = props["value"];
		groupbox.appendChild(input1);
		var getter7 = function() {
			return input1.value;
		};
		var setter1 = function(val) {
			input1.value = val;
		};
		component["getter"] = getter7;
		component["setter"] = setter1;
		if(param_name == "script") {
			input1.disabled = "disabled";
		}
	} else if(itype == "slider") {
		var input2 = host_UI_doc.createElement("sp-slider");
		input2.type = "number";
		input2.min = props["minimum"];
		input2.max = props["maximum"];
		input2.step = props["step"];
		input2.value = props["value"];
		input2.className = "param" + mode + Std.string(param_name);
		groupbox.appendChild(input2);
		var label = host_UI_doc.createElement("label");
		label.innerHTML = props["value"];
		label.className = "plabel" + mode + Std.string(param_name);
		groupbox.appendChild(label);
		input2.oninput = function(event) {
			host_UI.inputfix(input2,label);
		};
		var getter8 = function() {
			return input2.value;
		};
		var setter2 = function(val) {
			input2.value = val;
		};
		component["getter"] = getter8;
		component["setter"] = setter2;
	} else if(itype == "checkbox") {
		colsize = "col-2";
		var input3 = host_UI_doc.createElement("input");
		input3.type = "checkbox";
		input3.className = "param" + mode + Std.string(param_name);
		if(props["value"]) {
			input3.checked = "checked";
		}
		groupbox.appendChild(input3);
		var getter9 = function() {
			return input3.checked;
		};
		var setter3 = function(val) {
			if(val) {
				input3.checked = "checked";
			} else {
				input3.checked = null;
			}
		};
		component["getter"] = getter9;
		component["setter"] = setter3;
	} else if(itype == "number") {
		var input4 = host_UI_doc.createElement("input");
		input4.type = "text";
		input4.value = "-1";
		input4.className = "param" + mode + Std.string(param_name);
		groupbox.appendChild(input4);
		var getter10 = function() {
			return input4.value;
		};
		var setter4 = function(val) {
			input4.value = val;
		};
		component["getter"] = getter10;
		component["setter"] = setter4;
		var reset = host_UI_doc.createElement("sp-button");
		reset.textContent = "🎲";
		reset.addEventListener("click",function(event) {
			return component["setter"](-1);
		});
		groupbox.appendChild(reset);
		var keep = host_UI_doc.createElement("sp-button");
		keep.textContent = "♻️";
		keep.addEventListener("click",function(event) {
			return host_UI.asyncfetch([component]);
		});
		groupbox.appendChild(keep);
	} else if(itype == "checkboxgroup") {
		console.log("src/host/UI.js.hx:482:",component);
		var opt = props["choices"];
		var checks = [];
		var _g = 0;
		while(_g < opt.length) {
			var name = opt[_g];
			++_g;
			var chk = host_UI_doc.createElement("input");
			chk.className = "param" + mode + Std.string(param_name);
			chk.type = "checkbox";
			chk.checked = true;
			chk.id = name;
			var label1 = host_UI_doc.createElement("label");
			label1.className = "safe";
			label1.innerHTML = name;
			label1.htmlFor = name;
			groupbox.appendChild(chk);
			groupbox.appendChild(label1);
			checks.push(chk);
		}
		var getter11 = function() {
			var toggledopts = [];
			var _g = 0;
			var _g1 = opt.length;
			while(_g < _g1) {
				var i = _g++;
				if(checks[i].checked) {
					toggledopts.push(opt[i]);
				}
			}
			return toggledopts;
		};
		component["getter"] = getter11;
	}
	if(colsize != null) {
		groupbox.className = "group " + colsize;
	} else {
		groupbox.className = "group " + "col-auto";
	}
	if(!props["visible"] || host_UI.txt2img_data_outputs.indexOf(component["id"]) != -1) {
		groupbox.style.display = "none";
	}
	component["container"] = groupbox;
	return groupbox;
};
host_UI.getActiveTab = function() {
	var _g = 0;
	var _g1 = host_UI_doc.querySelectorAll(".sp-tab");
	while(_g < _g1.length) {
		var tab2 = _g1[_g];
		++_g;
		var tab21 = tab2;
		if(tab21.className.indexOf("selected") != -1) {
			return tab21;
		}
	}
	console.log("src/host/UI.js.hx:538:","error-called for nonexisting tab");
	return null;
};
host_UI.setParameter = async function(param_name,value) {
	console.log("src/host/UI.js.hx:543:","setting : " + param_name + " to value: " + Std.string(value));
	var mode = HxOverrides.substr(host_UI.getActiveTab().id,4,null);
	var qry = "." + "param" + mode + param_name;
	console.log("src/host/UI.js.hx:547:","Query : " + qry);
	var field = host_UI_doc.querySelectorAll(qry).item(0);
	console.log("src/host/UI.js.hx:549:","result: " + Std.string(field));
	if(field != null) {
		if(host_UIDefs_widgetinfo.h[param_name].inputtype == "CheckBox") {
			var bufElem = field;
			bufElem.checked = value;
		} else {
			var bufElem = field;
			bufElem.value = value;
		}
		if(host_UIDefs_widgetinfo.h[param_name].inputtype == "SpinBox") {
			var label = host_UI_doc.querySelectorAll("." + "plabel" + mode + param_name).item(0);
			label.innerHTML = value;
		}
	}
};
host_UI.gatherParameter = async function(param_name) {
	var mode = HxOverrides.substr(host_UI.getActiveTab().id,4,null);
	var qry = "." + "param" + mode + param_name;
	var field = host_UI_doc.querySelectorAll(qry).item(0);
	var param = null;
	if(field != null) {
		if(host_UIDefs_widgetinfo.h[param_name].inputtype == "outpainting_directions") {
			var allfields = host_UI_doc.querySelectorAll(qry);
			var arr = ["left","right","up","down"];
			if(!allfields[0].checked) {
				HxOverrides.remove(arr,"left");
			}
			if(!allfields[1].checked) {
				HxOverrides.remove(arr,"right");
			}
			if(!allfields[2].checked) {
				HxOverrides.remove(arr,"up");
			}
			if(!allfields[3].checked) {
				HxOverrides.remove(arr,"down");
			}
			param = arr;
		} else if(host_UIDefs_widgetinfo.h[param_name].inputtype == "CheckBox") {
			var bufElem = field;
			param = bufElem.checked;
		} else if(host_UIDefs_widgetinfo.h[param_name].inputtype == "prompt") {
			var bufElem = field;
			param = bufElem.value;
		} else {
			var bufElem = field;
			param = bufElem.value;
		}
	}
	if(param == null) {
		param = await host_UI.gatherSpecialParameter(param_name);
	}
	if(param == null) {
		console.log("src/host/UI.js.hx:608:","\nerror in gatherParameter");
		console.log("src/host/UI.js.hx:609:",param_name);
	}
	return param;
};
host_UI.gatherSpecialParameter = async function(param_name) {
	var state = await host_Image.getDocumentState();
	if(param_name == "img2img_image") {
		if(host_UI.is_inpainting == 0) {
			var mask = host_Image.layerByName("!sdmask");
			if(mask != null) {
				
                require("photoshop").core.executeAsModal(() => {
                    mask.visible=false; } )
                ;
			}
			var pngbytes = await host_Image.pngFromSelection(state.selection);
			var iobytes = haxe_io_Bytes.ofData(pngbytes);
			var base64string = "data:image/png;base64," + Utils.fastencode64(iobytes);
			return base64string;
		} else {
			return null;
		}
	}
	if(param_name == "img2maskimg") {
		return null;
	}
	if(param_name == "img_inpaint_base") {
		if(host_UI.is_inpainting == 1) {
			var mask = host_Image.layerByName("!sdmask");
			if(mask != null) {
				
                require("photoshop").core.executeAsModal(() => {
                    mask.visible=false; } )
                ;
			}
			var pngbytes = await host_Image.pngFromSelection(state.selection);
			var iobytes = haxe_io_Bytes.ofData(pngbytes);
			var base64string = "data:image/png;base64," + Utils.fastencode64(iobytes);
			return base64string;
		} else {
			return null;
		}
	}
	if(param_name == "img_inpaint_mask") {
		if(host_UI.is_inpainting == 1) {
			var layer = await host_Image.layerByName("!sdmask");
			var pngbytes = await host_Image.pngFromSelection(state.selection,layer);
			var iobytes = haxe_io_Bytes.ofData(pngbytes);
			var base64string = "data:image/png;base64," + Utils.fastencode64(iobytes);
			return base64string;
		} else {
			return null;
		}
	}
	if(param_name == "!mask_in") {
		var layer = await host_Image.layerByName("!sdmask");
		var pngbytes = await host_Image.pngFromSelection(state.selection,layer);
		var iobytes = haxe_io_Bytes.ofData(pngbytes);
		var base64string = "data:image/png;base64," + Utils.fastencode64(iobytes);
		return base64string;
	}
	if(param_name == "width") {
		return state.selection.width;
	}
	if(param_name == "height") {
		return state.selection.height;
	}
	if(param_name == "!Script") {
		return "None";
	}
	return "FIXME";
};
host_UI.extractValue = function(groupBox,param_name) {
	var widgetinfo = host_UIDefs_widgetinfo.h[param_name];
	var _g = 0;
	var _g1 = (js_Boot.__cast(groupBox , HTMLDivElement)).children;
	while(_g < _g1.length) {
		var child = _g1[_g];
		++_g;
		if(child.className.indexOf("param") != -1) {
			if(child.type == "checkbox") {
				return child.checked;
			} else {
				return child.value;
			}
		}
	}
	return "foo";
};
host_UI.addOptions = function(select,options) {
	var _g = 0;
	while(_g < options.length) {
		var o = options[_g];
		++_g;
		var opt = host_UI_doc.createElement("option");
		opt.value = o;
		opt.innerHTML = o;
		select.appendChild(opt);
	}
};
host_UI.getfloat = function(str) {
	var safelystr = new String(str);
	var foo = safelystr.split(",");
	var out = 0.;
	if(foo.length > 1) {
		out = parseFloat(foo[0]);
		if(foo[1].length != 0) {
			out += 0.1 * parseFloat(foo[1]);
		}
	} else {
		out = parseFloat(new String(str));
	}
	return out;
};
host_UI.inputfix = function(input,label) {
	label.innerHTML = input.value;
};
host_UI.inputfixOld = function(input) {
	var ival = host_UI.getfloat(input.value);
	var lastval = host_UI.getfloat(input.placeholder);
	var istep = host_UI.getfloat(input.step);
	var imax = host_UI.getfloat(input.max);
	var imin = host_UI.getfloat(input.min);
	var change = lastval - ival;
	var val = ival;
	if(change < 0 && change > -0.2) {
		val = Math.round(val / istep) * istep;
		val = lastval + istep;
	} else if(change > 0 && change < 0.2) {
		val = Math.round(val / istep) * istep;
		val = lastval - istep;
	}
	console.log("src/host/UI.js.hx:766:","change " + change);
	console.log("src/host/UI.js.hx:767:","lastval " + lastval);
	console.log("src/host/UI.js.hx:768:","val " + val);
	val = Math.min(imax,val);
	val = Math.max(imin,val);
	console.log("src/host/UI.js.hx:775:","sane val" + val);
	input.value = val == null ? "null" : "" + val;
	input.placeholder = val == null ? "null" : "" + val;
};
host_UI.createModeTab = function(mode) {
};
var hxasync_NoReturn = {};
hxasync_NoReturn._new = function(value) {
	var this1 = null;
	return this1;
};
var hxasync_AsyncMacroUtils = function() { };
hxasync_AsyncMacroUtils.__name__ = "hxasync.AsyncMacroUtils";
var js_Boot = function() { };
js_Boot.__name__ = "js.Boot";
js_Boot.getClass = function(o) {
	if(o == null) {
		return null;
	} else if(((o) instanceof Array)) {
		return Array;
	} else {
		var cl = o.__class__;
		if(cl != null) {
			return cl;
		}
		var name = js_Boot.__nativeClassName(o);
		if(name != null) {
			return js_Boot.__resolveNativeClass(name);
		}
		return null;
	}
};
js_Boot.__string_rec = function(o,s) {
	if(o == null) {
		return "null";
	}
	if(s.length >= 5) {
		return "<...>";
	}
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) {
		t = "object";
	}
	switch(t) {
	case "function":
		return "<function>";
	case "object":
		if(o.__enum__) {
			var e = $hxEnums[o.__enum__];
			var con = e.__constructs__[o._hx_index];
			var n = con._hx_name;
			if(con.__params__) {
				s = s + "\t";
				return n + "(" + ((function($this) {
					var $r;
					var _g = [];
					{
						var _g1 = 0;
						var _g2 = con.__params__;
						while(true) {
							if(!(_g1 < _g2.length)) {
								break;
							}
							var p = _g2[_g1];
							_g1 = _g1 + 1;
							_g.push(js_Boot.__string_rec(o[p],s));
						}
					}
					$r = _g;
					return $r;
				}(this))).join(",") + ")";
			} else {
				return n;
			}
		}
		if(((o) instanceof Array)) {
			var str = "[";
			s += "\t";
			var _g = 0;
			var _g1 = o.length;
			while(_g < _g1) {
				var i = _g++;
				str += (i > 0 ? "," : "") + js_Boot.__string_rec(o[i],s);
			}
			str += "]";
			return str;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( _g ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString && typeof(tostr) == "function") {
			var s2 = o.toString();
			if(s2 != "[object Object]") {
				return s2;
			}
		}
		var str = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		var k = null;
		for( k in o ) {
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str.length != 2) {
			str += ", \n";
		}
		str += s + k + " : " + js_Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str += "\n" + s + "}";
		return str;
	case "string":
		return o;
	default:
		return String(o);
	}
};
js_Boot.__interfLoop = function(cc,cl) {
	if(cc == null) {
		return false;
	}
	if(cc == cl) {
		return true;
	}
	var intf = cc.__interfaces__;
	if(intf != null) {
		var _g = 0;
		var _g1 = intf.length;
		while(_g < _g1) {
			var i = _g++;
			var i1 = intf[i];
			if(i1 == cl || js_Boot.__interfLoop(i1,cl)) {
				return true;
			}
		}
	}
	return js_Boot.__interfLoop(cc.__super__,cl);
};
js_Boot.__instanceof = function(o,cl) {
	if(cl == null) {
		return false;
	}
	switch(cl) {
	case Array:
		return ((o) instanceof Array);
	case Bool:
		return typeof(o) == "boolean";
	case Dynamic:
		return o != null;
	case Float:
		return typeof(o) == "number";
	case Int:
		if(typeof(o) == "number") {
			return ((o | 0) === o);
		} else {
			return false;
		}
		break;
	case String:
		return typeof(o) == "string";
	default:
		if(o != null) {
			if(typeof(cl) == "function") {
				if(js_Boot.__downcastCheck(o,cl)) {
					return true;
				}
			} else if(typeof(cl) == "object" && js_Boot.__isNativeObj(cl)) {
				if(((o) instanceof cl)) {
					return true;
				}
			}
		} else {
			return false;
		}
		if(cl == Class ? o.__name__ != null : false) {
			return true;
		}
		if(cl == Enum ? o.__ename__ != null : false) {
			return true;
		}
		return o.__enum__ != null ? $hxEnums[o.__enum__] == cl : false;
	}
};
js_Boot.__downcastCheck = function(o,cl) {
	if(!((o) instanceof cl)) {
		if(cl.__isInterface__) {
			return js_Boot.__interfLoop(js_Boot.getClass(o),cl);
		} else {
			return false;
		}
	} else {
		return true;
	}
};
js_Boot.__cast = function(o,t) {
	if(o == null || js_Boot.__instanceof(o,t)) {
		return o;
	} else {
		throw haxe_Exception.thrown("Cannot cast " + Std.string(o) + " to " + Std.string(t));
	}
};
js_Boot.__nativeClassName = function(o) {
	var name = js_Boot.__toStr.call(o).slice(8,-1);
	if(name == "Object" || name == "Function" || name == "Math" || name == "JSON") {
		return null;
	}
	return name;
};
js_Boot.__isNativeObj = function(o) {
	return js_Boot.__nativeClassName(o) != null;
};
js_Boot.__resolveNativeClass = function(name) {
	return $global[name];
};
var js_Browser = function() { };
js_Browser.__name__ = "js.Browser";
js_Browser.__properties__ = {get_supported:"get_supported"};
js_Browser.get_supported = function() {
	if(typeof(window) != "undefined" && typeof(window.location) != "undefined") {
		return typeof(window.location.protocol) == "string";
	} else {
		return false;
	}
};
js_Browser.createXMLHttpRequest = function() {
	if(typeof XMLHttpRequest != "undefined") {
		return new XMLHttpRequest();
	}
	if(typeof ActiveXObject != "undefined") {
		return new ActiveXObject("Microsoft.XMLHTTP");
	}
	throw haxe_Exception.thrown("Unable to create XMLHttpRequest object.");
};
function $getIterator(o) { if( o instanceof Array ) return new haxe_iterators_ArrayIterator(o); else return o.iterator(); }
function $bind(o,m) { if( m == null ) return null; if( m.__id__ == null ) m.__id__ = $global.$haxeUID++; var f; if( o.hx__closures__ == null ) o.hx__closures__ = {}; else f = o.hx__closures__[m.__id__]; if( f == null ) { f = m.bind(o); o.hx__closures__[m.__id__] = f; } return f; }
$global.$haxeUID |= 0;
if(typeof(performance) != "undefined" ? typeof(performance.now) == "function" : false) {
	HxOverrides.now = performance.now.bind(performance);
}
if( String.fromCodePoint == null ) String.fromCodePoint = function(c) { return c < 0x10000 ? String.fromCharCode(c) : String.fromCharCode((c>>10)+0xD7C0)+String.fromCharCode((c&0x3FF)+0xDC00); }
String.prototype.__class__ = String;
String.__name__ = "String";
Array.__name__ = "Array";
var Int = { };
var Dynamic = { };
var Float = Number;
var Bool = Boolean;
var Class = { };
var Enum = { };
haxe_ds_ObjectMap.count = 0;
js_Boot.__toStr = ({ }).toString;
var Defs_fn_indices = (function($this) {
	var $r;
	var _g = new haxe_ds_StringMap();
	_g.h["txt2img"] = 13;
	_g.h["img2img"] = 33;
	_g.h["inpaint"] = 33;
	_g.h["Outpainting_mk2"] = 33;
	_g.h["SD Upscale"] = 33;
	$r = _g;
	return $r;
}(this));
var Defs_baseurl = "http://localhost.tech:7860";
var Defs_defaults = (function($this) {
	var $r;
	var _g = new haxe_ds_StringMap();
	_g.h["Outpainting_mk2"] = [0,"a cute dog","evil","None","None","data:image/png;base64,",null,null,null,"Draw mask",20,"Euler a",4,"fill",false,false,1,1,7,0.75,-1,-1,0,0,0,true,512,512,"Just resize",false,32,"Inpaint masked","","","Outpainting mk2","Nonsense",true,true,"","",true,50,true,1,0,false,4,1,"Nonsense",120,7,["left","up","down"],1.02,0.06,128,4,"fill",["left","right","up","down"],false,false,null,"","Nonsense",64,"None","Seed","","Nothing","",true,false,false,null,"",""];
	$r = _g;
	return $r;
}(this));
var Defs_ui_tags = (function($this) {
	var $r;
	var _g = new haxe_ds_StringMap();
	_g.h["Outpainting_mk2"] = [null,"prompt","negative_prompt",null,null,"!img_in",null,null,null,null,"steps","sampler",null,null,"restore_faces","tiling","batch_count","batch_size","cfg_scale","denoising_strength","seed","subseed","subseed_strength","seed_resize_from_w","seed_resize_from_h",null,"!img_height","!img_width",null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,"outpainting_pixels_to_expand","outpainting_mask_blur","outpainting_directions","outpainting_falloff_exponent","outpainting_color_variation",null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
	$r = _g;
	return $r;
}(this));
MyDocker.__meta__ = { statics : { checkReady : { async : null}}, fields : { generate2 : { async : null}, generate : { async : null}}};
Utils.__meta__ = { statics : { receive : { async : null}}};
Utils.params_for_layer = [];
haxe_crypto_Base64.CHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
haxe_crypto_Base64.BYTES = haxe_io_Bytes.ofString(haxe_crypto_Base64.CHARS);
host_App.__meta__ = { statics : { getDocumentState : { async : null}, setDocumentState : { async : null}}};
host_App.gradio_components = [];
host_App.gradio_dependencies = [];
host_Image.__meta__ = { statics : { pngFromLayer : { async : null}, pngFromSelection_SingleLayer : { async : null}, pngFromSelection : { async : null}, layerFromPng : { async : null}, setLayerName : { async : null}, special_fillBk_screen : { async : null}, writeLayerToDisk : { async : null}, readBytesFromDisk : { async : null}, writeBytesToDisk : { async : null}, loadFileAsLayer : { async : null}, getDocumentState : { async : null}, deselect : { async : null}, setDocumentState : { async : null}, createLayer : { async : null}}};
host_UI.__meta__ = { statics : { asyncfetch : { async : null}, setParameter : { async : null}, gatherParameter : { async : null}, gatherSpecialParameter : { async : null}}};
host_UI.txt2img_data_inputs = [];
host_UI.txt2img_data_outputs = [];
host_UI.img2img_data_inputs = [];
host_UI.img2img_data_outputs = [];
host_UI.is_inpainting = 0;
host_UI.tags = (function($this) {
	var $r;
	var _g = new haxe_ds_StringMap();
	_g.h["txt2img"] = [];
	_g.h["img2img"] = [];
	_g.h["inpaint"] = [];
	_g.h["outpainting_mk2"] = [];
	$r = _g;
	return $r;
}(this));
var host_UI_doc = window.document;
var host_UIDefs_samplers = ["Euler a","Euler","LMS","Heun","DPM2","DPM2 a","DPM fast","DPM adaptive","LMS Karras","DPM2 Karras","DPM2a Karras","DDIM","PLMS"];
var host_UIDefs_widgetinfo = (function($this) {
	var $r;
	var _g = new haxe_ds_StringMap();
	_g.h["prompt"] = { inputtype : "prompt", fdefault : "a cute dog"};
	_g.h["negative_prompt"] = { inputtype : "prompt", fdefault : "evil"};
	_g.h["steps"] = { inputtype : "SpinBox", fdefault : 20, range : { min : 1, max : 200, step : 1}};
	_g.h["sampler"] = { inputtype : "ComboBox", fdefault : "Euler a", comboBoxOptions : host_UIDefs_samplers};
	_g.h["restore_faces"] = { inputtype : "CheckBox", fdefault : false};
	_g.h["tiling"] = { inputtype : "CheckBox", fdefault : false};
	_g.h["batch_count"] = { inputtype : "SpinBox", fdefault : 1, range : { min : 1, max : 32, step : 1}};
	_g.h["batch_size"] = { inputtype : "SpinBox", fdefault : 1, range : { min : 1, max : 16, step : 1}};
	_g.h["cfg_scale"] = { inputtype : "SpinBox", fdefault : 7, range : { min : -10, max : 64, step : 0.5}};
	_g.h["seed"] = { inputtype : "seed", fdefault : -1};
	_g.h["subseed"] = { inputtype : "seed", fdefault : -1};
	_g.h["subseed_strength"] = { inputtype : "SpinBox", fdefault : 0, range : { min : 0, max : 1, step : 0.05}};
	_g.h["seed_resize_from_h"] = { inputtype : "SpinBox", fdefault : 0, range : { min : 0, max : 1024, step : 64}};
	_g.h["seed_resize_from_w"] = { inputtype : "SpinBox", fdefault : 0, range : { min : 0, max : 1024, step : 64}};
	_g.h["highres_fix"] = { inputtype : "CheckBox", fdefault : false};
	_g.h["highres_fix_scale_latent"] = { inputtype : "CheckBox", fdefault : false};
	_g.h["highres_fix_noise_scale"] = { inputtype : "SpinBox", fdefault : 0.7, range : { min : 0, max : 1, step : 0.01}};
	_g.h["denoising_strength"] = { inputtype : "SpinBox", fdefault : 0.75, range : { min : 0, max : 1, step : 0.01}};
	_g.h["mask_blur"] = { inputtype : "SpinBox", fdefault : 4, range : { min : 0, max : 512, step : 1}};
	_g.h["masked_content"] = { inputtype : "ComboBox", fdefault : "fill", comboBoxOptions : ["fill","original","latent noise","latent nothing"]};
	_g.h["inpaint_at_full_res"] = { inputtype : "CheckBox", fdefault : false};
	_g.h["outpainting_pixels_to_expand"] = { inputtype : "SpinBox", fdefault : 8, range : { min : 8, max : 128, step : 8}};
	_g.h["outpainting_mask_blur"] = { inputtype : "SpinBox", fdefault : 4, range : { min : 0, max : 64, step : 1}};
	_g.h["outpainting_directions"] = { inputtype : "outpainting_directions", fdefault : ["left","right","up","down"]};
	_g.h["outpainting_falloff_exponent"] = { inputtype : "SpinBox", fdefault : 1, range : { min : 0, max : 4, step : 0.01}};
	_g.h["outpainting_color_variation"] = { inputtype : "SpinBox", fdefault : 0.05, range : { min : 0, max : 1, step : 0.01}};
	_g.h["upscale_tile_overlap"] = { inputtype : "SpinBox", fdefault : 64, range : { min : 16, max : 256, step : 16}};
	_g.h["upscaler"] = { inputtype : "ComboBox", comboBoxOptions : ["Lanczos","None","Real-ESRGAN 4x plus","Real-ESRGAN 4x plus anime 6B","LDSR"]};
	_g.h["firstpass_width"] = { inputtype : "SpinBox", fdefault : 0, range : { min : 0, max : 1024, step : 64}};
	_g.h["firstpass_height"] = { inputtype : "SpinBox", fdefault : 0, range : { min : 0, max : 1024, step : 64}};
	_g.h["Ae_learn_rate"] = { inputtype : "string", fdefault : "0.0001"};
	_g.h["Ae_weight"] = { inputtype : "SpinBox", fdefault : 0.9, range : { min : 0, max : 1, step : 0.01}};
	_g.h["Ae_steps"] = { inputtype : "SpinBox", fdefault : 5, range : { min : 0, max : 50, step : 1}};
	_g.h["Ae_embedding"] = { inputtype : "string", fdefault : "None"};
	_g.h["Ae_slerp"] = { inputtype : "CheckBox", fdefault : false};
	_g.h["Ae_text"] = { inputtype : "string", fdefault : ""};
	_g.h["Ae_slerp_angle"] = { inputtype : "SpinBox", fdefault : 0.1, range : { min : 0, max : 1, step : 0.01}};
	_g.h["Ae_negative"] = { inputtype : "CheckBox", fdefault : false};
	$r = _g;
	return $r;
}(this));
var host_UIDefs_parameterNames = (function($this) {
	var $r;
	var _g = new haxe_ds_StringMap();
	_g.h["variation_seed"] = "subseed";
	_g.h["variation_strength"] = "subseed_strength";
	_g.h["sampling_steps"] = "steps";
	_g.h["sampling_method"] = "sampler";
	_g.h["resize_seed_from_height"] = "resize_seed_from_h";
	_g.h["resize_seed_from_width"] = "resize_seed_from_w";
	$r = _g;
	return $r;
}(this));
Main.main();
})(typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this);
